'use strict';

const prelude = `
#include <stdio.h>
#include <stdlib.h>
	
`

const mainHeader = `
int main() {
`

const mainFooter = `
}
`

class TranslationData {
  constructor() {
    this.conDecls = "";
	this.methods = "";
	this.currentBody = "";
	  
	this.methodNames = new Set();
	this.methodNames.add("prettyPrint"); // build-in method
	this.fieldNames = new Set();
	this.classes = new Map();
	  
    this.cons = "";
	this.lastFlag = "";
  }
  generate() {
	var objDefn = "struct Object {\n";
	objDefn += "    char *classname;\n";
	this.methodNames.forEach(m => (objDefn += "    void *" + m + ";\n"));
	this.fieldNames.forEach(f => (objDefn += "    struct Object *" + f + ";\n"));
	objDefn += "};\n";
	objDefn += "typedef struct Object *Obj;\n\n";
	this.classes.forEach(c => c.addConstructor(this));
  	return prelude + objDefn + this.conDecls + this.methods + this.cons + mainHeader + this.currentBody + mainFooter;
  }

}

function trans(ast) {
	let data = new TranslationData();
	ast.translate(data);
  	return data.generate();
	//return "1+2*3";
}

